window.onload = pageLoaded()

function pageLoaded() {
    drawVersion()
    checkVersion()
    setUpScriptIcon()

// script identity and content variables
    
    gTALineNumbers = document.getElementById("taLineNumbers")
    gTAScript = document.getElementById("taScript")
    gTALineRefs = document.getElementById("taLineRefs")
    gPErrorMessage = document.getElementById("pErrorMessage")
    
    gIconNeatL = document.getElementById("iconNeatL")
    gIconDebugL = document.getElementById("iconDebugL")
    gIconRunL = document.getElementById("iconRunL")
    gIconNeatR = document.getElementById("iconNeatR")
    gIconDebugR = document.getElementById("iconDebugR")
    gIconRunR = document.getElementById("iconRunR")
    
    gScriptAsBlocks =  []
    gTheOldScript = "not initialised"
    gTheOldScriptHeight = "not initialised"
    gTheOldScrollPos = "not initialised"

    checkForScript()
    checkForLogs()
    window.addEventListener('storage', myStorageHandler, false)
    updateLogLabel()
    makeLineNumberString()
    
    updateDisplay()
    window.setInterval("updateDisplay()", 3000)
    clickButtonMove('left')
}

// ----------------------------- dragging -----------------------------

function dragoverScriptIcon(theEvent) {
    theEvent.dataTransfer.dropEffect = 'copy'
    theEvent.preventDefault()
}

function dragenterScriptIcon(theEvent) {
    theEvent.dataTransfer.dropEffect = 'copy'
    theEvent.preventDefault()
}

function dropScriptIcon(theEvent) {
    theEvent.stopPropagation()
    theEvent.preventDefault()
    
    var theFile = theEvent.dataTransfer.files[0]
//console.log('theFile',theFile)

    if ((theFile.type != "text/plain") && (theFile.type != "")) {
        alert("That file is the wrong type of file.  A script file is a plaintext file.  Please drop a different file.")
    } else if ((theFile.name.indexOf(".psyScript") == -1) && (theFile.name.indexOf(".txt") == -1)) {
        alert("That file is not a PsyScript script file.  A script file has a name which ends with '.psyScript' or '.txt'.  Please drop a different file.")
    } else {
        
        var theReader = new FileReader()
        theReader.name = theFile.name
        theReader.type = theFile.type
        theReader.addEventListener("loadend", function () {readScriptFileEnd(theReader)}, false)
        theReader.readAsText(theFile)
    }
    
    return false
}

function readScriptFileEnd(theReader) {
//console.log('theReader',theReader)
    var temp = document.getElementById("spanFilename")
    temp.innerHTML = theReader.name
    localStorage.setItem('psyscript3_scriptFilename', theReader.name)

    gScriptAsBlocks = "not initialised"
    gTAScript.value = theReader.result
    updateDisplay()
}

// never gets used browser cannot create a file
function xxxdragstartScriptIcon(theEvent) {
    console.log("dragstartScriptIcon")
    
    var theScriptIcon = document.getElementById("imgScriptIcon")
    
    theEvent.dataTransfer.dropEffect = "copy"
    theEvent.dataTransfer.effectAllowed = "copy"
    theEvent.dataTransfer.setData("application/octet", "hello mom")
    console.log(theEvent.dataTransfer)
    
    console.log("done")
}

// never gets used browser cannot create a file
function xxxdragendScriptIcon(theEvent) {
    console.log("dragendScriptIcon")
}

// ----------------------------- startup -----------------------------

function setUpScriptIcon() {
    var theScriptIcon = document.getElementById("imgScriptIcon")
    theScriptIcon.draggable = true
    
    theScriptIcon.addEventListener("dragover", dragoverScriptIcon, false)
    theScriptIcon.addEventListener("dragenter", dragenterScriptIcon, false)
    theScriptIcon.addEventListener("drop", dropScriptIcon, false)
//    theScriptIcon.addEventListener("dragstart", dragstartScriptIcon, false)
//    theScriptIcon.addEventListener("dragend", dragendScriptIcon, false)
}

function drawVersion() {
    var theNavDiv = document.getElementById("divNav")
    util_removeAllChildren(theNavDiv)
    
    theNavDiv.innerHTML = 'Version '+gVersion+' <a style="text-decoration:underline" onclick="doc_openDocumentation()">Documentation</a>&nbsp;&nbsp;&nbsp;<a style="text-decoration:underline" onclick="doc_openCheatSheet()">Cheat Sheet</a>'
}

function doc_openDocumentation() {
    util_openhelp("index")
}

function doc_openCheatSheet() {
    util_openhelp("cheatSheet")
}

function checkForScript() {
    if (!localStorage.getItem('psyscript3_scriptFilename') || (localStorage.getItem('psyscript3_scriptFilename')) == "") {
        localStorage.setItem('psyscript3_scriptFilename', "no script loaded")
    } else {
        var temp = document.getElementById("spanFilename")
        temp.innerHTML = localStorage.getItem('psyscript3_scriptFilename')
    }
    
    if (!localStorage.getItem('psyscript3_scriptAsText') || (localStorage.getItem('psyscript3_scriptAsText') == "")) {
        localStorage.setItem('psyscript3_scriptAsText', "define fileFormat PsyScript script format 2.0\ndefine homeFolder unknown\ndefine logMethod localStorage\n\nproc main\n  -- commands go here\nend proc")
    
        gTAScript.value = localStorage.getItem('psyscript3_scriptAsText')
        gTAScript.selectionStart = 73
        gTAScript.selectionEnd = 92
    } else {
        gTAScript.value = localStorage.getItem('psyscript3_scriptAsText')
    }
}

// format for logs: list of individual log entries
// format for individual log entry: [scriptname, datetime, [longlines]]
function checkForLogs() {
    if (!localStorage.getItem('psyscript3_logs')) {
        var temp = []
        localStorage.setItem('psyscript3_logs', JSON.stringify(temp))
    }
}

// five characters plus a return for each line number
function makeLineNumberString() {
    gLineNumbers = ""
    
    for (var i = 1; i<10000; i++) {
        var temp = "     "+i.toFixed(0)
        gLineNumbers += temp.substr(-4) +" "+ gReturn
    }
}

// ----------------------------- regular updates -----------------------------

function updateDisplay() {
    if (gTAScript.value != gTheOldScript) updateScriptDisplay(gTAScript.value)
    if (gTAScript.offsetHeight != gTheOldScriptHeight) scriptResized(gTAScript.offsetHeight)
    if (gTAScript.scrollTop != gTheOldScrollPos) scriptScrolled(gTAScript.scrollTop)
}

function updateScriptDisplay(theScript) {
    var numberOfLinesInScript = theScript.split(gReturn).length
    gTALineNumbers.value = gLineNumbers.substr(0,6 * numberOfLinesInScript)
    
    localStorage.setItem('psyscript3_scriptAsText', theScript)
    gTheOldScript = theScript
    
    // At this point the script gets parsed.  The parsing routine should
    // accept one parameter (the script as text) and return an object
    // containing text, array, array
    // [errorLine, errorMessage, scriptBlocks, lineRefs]
    
    var parseResults = pa_parseScript(theScript)
    var errorLine = parseResults.errorLine
    var errorMessage = parseResults.errorMessage
    var lineRefs = parseResults.lineRefs
    gTALineRefs.value = lineRefs.join(gReturn)
    gSyntaxCheckOkay = (errorLine == -1)
    
    if (errorLine == -1) {
        gPErrorMessage.className = "greentext"
        gPErrorMessage.innerHTML = "No errors found."
        
        gIconNeatL.className = "imageDimOff"
        gIconDebugL.className = "imageDimOff"
        gIconRunL.className = "imageDimOff"
        gIconNeatR.className = "imageDimOff"
        gIconDebugR.className = "imageDimOff"
        gIconRunR.className = "imageDimOff"
        
        gTALineNumbers.className = "greenbackground"
        gTALineRefs.className = "greenbackground"
    } else {
        gPErrorMessage.className = "redtext"
        gPErrorMessage.innerHTML = "Error at line "+(errorLine+1)+":<br \>"+errorMessage+"."
        
        gIconNeatL.className = "imageDimOn"
        gIconDebugL.className = "imageDimOn"
        gIconRunL.className = "imageDimOn"
        gIconNeatR.className = "imageDimOn"
        gIconDebugR.className = "imageDimOn"
        gIconRunR.className = "imageDimOn"
        
        gTALineNumbers.className = "redbackground"
        gTALineRefs.className = "redbackground"
    }
    
    gScriptAsBlocks = parseResults.blocks
}

function scriptResized(raw) {
    var theFactor = (gTALineNumbers.offsetHeight) / gTALineNumbers.rows
    var newHeight = Math.round((gTAScript.offsetHeight)/ theFactor)

    gTAScript.rows = newHeight
    gTALineNumbers.rows = newHeight
    gTALineRefs.rows = newHeight
    
    gTheOldScriptHeight = gTAScript.offsetHeight
}

function scriptScrolled(newHeight) {
    gTALineNumbers.scrollTop = newHeight
    gTALineRefs.scrollTop = newHeight
    
    gTheOldScrollPos = newHeight
}

// ------------------------- deal with store changes -------------------------

function myStorageHandler(theEvent) {

    if (theEvent.newValue != null) {
        switch (theEvent.key) {
        
            case "psyscript3_logs":
                updateLogLabel()
                break
              
            default:
                // most things take care of themselves
              
        }
    }
}

function updateLogLabel() {
    var theLogs = JSON.parse(localStorage.getItem('psyscript3_logs'))
    var theLabel = theLogs.length + " logs"
    
    var theLogSpan = document.getElementById("spanLogLabelL")
    theLogSpan.innerHTML = theLabel
    var theLogSpan = document.getElementById("spanLogLabelR")
    theLogSpan.innerHTML = theLabel
}

// ---------------------------  buttons -------------------------

function clickButtonHelp() {
    util_openhelp("index")
}

function clickButtonCheat() {
    util_openhelp("cheatSheet")
}

function clickButtonWipe() {
    if (!confirm("This button wipes all of psyScript's storage in this browser including the text of the script you're working on and logs of results.  Are you sure you want to do that ?")) return
    
    for (var i=localStorage.length-1; i>=0; i--) {
        var theKeyName = localStorage.key(i)
        if (theKeyName.substr(0,9) == 'psyscript') {
            localStorage.removeItem(theKeyName)
        }
        if (theKeyName.substr(0,9) == 'psyScript') {
            localStorage.removeItem(theKeyName)
        }
    }
    window.close()  // this will probably fail because it's not allowed
}

function clickButtonNeat() {
    if (gSyntaxCheckOkay) {
        var soFar = pa_unparse(gScriptAsBlocks)
        gTAScript.value = soFar
        updateDisplay()
    }
}

function clickButtonDebug() {
    if (gSyntaxCheckOkay) {
        runItWithFile('debug.html', "")
    }
}

function clickButtonRun() {
    if (gSyntaxCheckOkay) {
        runItWithFile('run.html', ",fullscreen=yes")
    }
}

function clickButtonLogs() {
    window.open("logs.html", "_blank", "width=1002,height=700,location=no,menubar=no,top=200,left=300,toolbar=no")
}

function clickButtonMove(destination) {
    var navLeft = document.getElementById("tdNavLeft")
    var navRight = document.getElementById("tdNavRight")
    if (destination == "right") {
        navLeft.style.visibility = "collapse"
        navRight.style.visibility = "visible"
    } else {
        navLeft.style.visibility = "visible"
        navRight.style.visibility = "collapse"
    }
}

function runItWithFile(theHTMLFile, extraStuff) {
    var temp = pa_compile(gScriptAsBlocks)
    var fileFormat = util_lookInObjList(temp.defines, 'fileFormat').content
    var homeFolder = util_lookInObjList(temp.defines, 'homeFolder').content
    var logMethod = util_lookInObjList(temp.defines, 'logMethod').content
    if (fileFormat != "PsyScript script format 2.0") {
    
        alert("I only know how to run scripts in format 2.0.")
        
    } else if (homeFolder == "unknown") {
        alert("You have not set a homefolder.  Find the file 'whatsMyPath.html' in the folder where your script is, open it in your browser, and do what it says.")
        
//    } else if (logMethod != "localStorage") {
//        alert("I only know how to save logs in your browser's localStorage.")
        
    } else {
    
        localStorage.setItem('psyscript3_scriptAsTokens', JSON.stringify(temp))
        window.open(theHTMLFile, "_blank", "location=no,menubar=no,top=200,left=300,toolbar=no,status=no,directories=no"+extraStuff)
    
    }
}

// ------------------------ checking version -----------------------

function checkVersion() {
    var temp = localStorage.getItem('psyscript3_versionCheck')
    if (temp) {
        gVersionCheck = JSON.parse(temp)
    } else {
        gVersionCheck = new Object
        gVersionCheck.nextCheck = new Date().getTime()
        gVersionCheck.checkInterval = 1000 * 60 * 60 * 24
    }

    // is it time to check for a new version ?
    var timeNow = new Date().getTime()
    if (timeNow < gVersionCheck.nextCheck) return
    
    // if you got here, it's time to check for a new version
    gVersionCheck.lastCheck = new Date().getTime()
    
    var requestObject = new Object
    requestObject.myVersion = gVersion
    
    var theURL = "http://www.psych.lancs.ac.uk/software/PsyScript3/versionCheck.php?myVersion="+gVersion
    
    gVersionCheckRequest = new XMLHttpRequest()
    gVersionCheckRequest.onreadystatechange = checkVersionReturned
    gVersionCheckRequest.open("POST", theURL, true)
//    gVersionCheckRequest.setRequestHeader('Content-Type', 'application/json')
    gVersionCheckRequest.send(JSON.stringify(requestObject))
}
    
function checkVersionReturned(theEvent) {
    if (gVersionCheckRequest.readyState !== 4) return
    
    // status is usually 200 (found) 404 (wrong page) or 0 (server dead)
    if (gVersionCheckRequest.status !== 200) return
    
    var responseJSON = theEvent.currentTarget.responseText
    var returnObject = JSON.parse(responseJSON)
    
    if (returnObject.status == "can't") {
        var temp = document.getElementById("divCheckVersion")
        temp.style.display = "none"
        
        checkVersionAddAnotherOne(gVersionCheck.checkInterval)
    } else {
        var temp = document.getElementById("divCheckVersion")
        temp.style.display = "block"
        
        var temp = document.getElementById("spanMyVersion")
        temp.innerHTML = returnObject.yourVersion
        var temp = document.getElementById("spanStatus")
        temp.innerHTML = returnObject.status
        var temp = document.getElementById("spanLatestVersion")
        temp.innerHTML = returnObject.latestVersion
        var temp = document.getElementById("aUpdatePage")
        temp.href = returnObject.updatePage
        
        var temp = document.getElementById("divCheckVersion")
        temp.style.top = "100px"
        temp.style.left = "100px"
    }
}

function clickButtonVersionCheck(theEvent) {
    var temp = document.getElementById("divCheckVersion")
    temp.style.display = "none"
    
    var targetId = theEvent.target.id
    var intervalLength = 1000 * 60 * 60 * 24
    if (targetId == 'buttonVersionWeek') intervalLength = intervalLength * 7
    if (targetId == 'buttonVersionMonth') intervalLength = intervalLength * 30
    if (targetId == 'buttonVersionYear') intervalLength = intervalLength * 365
    if (targetId == 'buttonVersionNever') intervalLength = intervalLength * 3650

    checkVersionAddAnotherOne(intervalLength)
}

function checkVersionAddAnotherOne(intervalLength) {
    gVersionCheck.checkInterval = intervalLength
    gVersionCheck.nextCheck = gVersionCheck.lastCheck + intervalLength
    localStorage.setItem('psyscript3_versionCheck', JSON.stringify(gVersionCheck))
    gVersionCheck = undefined
}
