// version 0.9.6
// this runtime library is used by debug.html and run.html and experimentRun.html

function pageLoaded() {
    gCellNameList = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    
    var temp = JSON.parse(localStorage.getItem('psyscript3_scriptAsTokens'))
    gTextblocks = temp.textBlocks
    gTables = temp.tables
    gSteps = temp.steps
    gDefines = temp.defines

    gScriptPath = util_lookInObjList(gDefines, "homeFolder").content+"/"

    var theParamsDialog = document.getElementById("divDisplaySavingParams")
    theParamsDialog.style.display="none"

    startNewParticipant()
    gShouldDoMoreStepsNow = true
    doNextStep()
}

// ------------------------ handle step progression ---------------------

function doCarryOn() {
    gShouldDoMoreStepsNow = true
    doNextStep()
}

function doNextStep() {
    if (gStillRunning) {
        window.setTimeout('doCurrentStep()', gDebugPauseTime)
    } else {
        endThisParticipant()
    }
}

function showLogModificationDialog() {
    var theParamsDialog = document.getElementById("divDisplaySavingParams")
    theParamsDialog.style.display = "block"
    
    var theTbody = document.getElementById("tbodySavingParamsLog")
    logDebugDisplayUpdate(theTbody, gLog)
}

// ------------------------- handling termination -------------------------

function substVarsIntoLog() {
    var inputExperiment = document.getElementById("inputExperiment")
    var inputParticipant = document.getElementById("inputParticipant")
    var inputComments = document.getElementById("inputComments")
    
//    gLog = gLog.replace("$experiment",inputExperiment.value)
//    gLog = gLog.replace("$participant",inputParticipant.value)
//    gLog = gLog.replace("$comments",inputComments.value)
    
    gLog = util_replaceAll(
        util_replaceAll(
            util_replaceAll(
                gLog,
                "$experiment",inputExperiment.value),
            "$participant",inputParticipant.value),
        "$comments",inputComments.value)
}

function writeThisLogToLogs() {
    var logMethod = util_lookInObjList(gDefines, "logMethod").content
    
    if (logMethod == "none") {
    
        // don't log anything
    
    } else if (logMethod == "localStorage") {
    
        var d = new Date()
        var u = window.navigator.userAgent
        var newLog = {thePath: gScriptPath,
                        theDate: d.toString(),
                        userAgent: u,
                        log: gLog}
        var existingLogs = JSON.parse(localStorage.getItem('psyscript3_logs'))
        existingLogs.unshift(newLog)
        localStorage.setItem('psyscript3_logs', JSON.stringify(existingLogs))
    
    } else {
    
        var thePos = logMethod.indexOf(" ")
        var theURL = logMethod.substr(0,thePos)
        var theDestKey = logMethod.substr(thePos+1)
        
        var requestObject = new Object
        requestObject.theDestKey = theDestKey
        requestObject.theLog = gLog
        requestObject.thePath = gScriptPath
        
        var HTTPRequest = new XMLHttpRequest()
        HTTPRequest.open("POST", theURL, false)
        HTTPRequest.setRequestHeader('Content-Type', 'application/json')
        HTTPRequest.send(JSON.stringify(requestObject))
    
    }
}

function buttonSavingParamsAgain() {
    substVarsIntoLog()
    writeThisLogToLogs()

    var theParamsDialog = document.getElementById("divDisplaySavingParams")
    theParamsDialog.style.display="none"
    
    startNewParticipant()
    doCarryOn()    
}

function buttonSavingParamsFinished() {
    substVarsIntoLog()
    writeThisLogToLogs()
    
    window.close()
}

function generateErrorAndHalt(errorMessage) {
    addToLog(gReturn)
    addToLog(gReturn)
    addToLog("Halt caused by error:")
    addToLog(errorMessage)
    addToLog(gReturn)
    addToLog("in step:")
    addToLog(gSteps[gPC].stepText)
    addToLog(gReturn)
    addToLog("at line:")
    addToLog(gSteps[gPC].scriptLineNum)
    gShouldDoMoreStepsNow = false
    gStillRunning = false
    
    endThisParticipant()
}

// ------------------------- handling parameters -------------------------

function cellNameToNumber(cellName) {
    return gCellNameList.indexOf(cellName)
}

function cellNumberToFullName(cellNumber) {
    return "cell"+gCellNameList.charAt(cellNumber)
}

function varEval(raw) {
    switch (raw) {
        case '$timeStamp':
            var temp = new Date()
            return temp.toTimeString().substr(0,8)
            
        case '$dateStamp':
            var temp = new Date()
            return temp.toDateString()
            
        case '$lastEventEnder':
            return gScriptVars.leEnder
            
        case '$lastEventTime':
            return (gScriptVars.leEndTime - gScriptVars.leStartTime) / 1000
            
        case '$lastClick':
            return gScriptVars.leLastClick
            
        case '$lastClickX':
            return gScriptVars.leLastClickX
            
        case '$lastClickY':
            return gScriptVars.leLastClickY
            
        case '$lastKey':
            return gScriptVars.leLastKey
            
        case '$timerTime':
            return (new Date().getTime() - gUserTimer) / 1000
            
        case '$countdownTime':
            var temp = (gUserCountdown - new Date().getTime()) / 1000
            return (temp > 0)?temp.toString():'expired'
            
        case '$random5':
            return util_makeRandomID(5)
            
        case '$blank':
            return ''
            
        case '$return':
            return gReturn
            
        case '$space':
            return ' '
            
        case '$tab':
            return gTab
            
        case '$experiment':
        case '$participant':
        case '$comments':
            return raw
            
        case '$lastResponses':
            return gScriptVars.lsResponses
    }
    
    if (raw.charAt(0) == '$') {
    
        if ((raw.length == 11) && (raw.substr(0,10) == "$cellValue")) {
            var cellNumber = cellNameToNumber(raw.substr(10,1))
            return gCellList[cellNumber].content
        }
        
        var temp = stackFindValue('variable',raw)
        if (typeof(temp) != 'boolean') {
            return temp
        } else {
            generateErrorAndHalt("No such variable '"+raw+"'.")
        }
    } else {
        return raw
    }
}

function varEvalInt(raw) {
    if (typeof raw == "number") {
        return parseInt(raw)
    } else {
        return parseInt(varEval(raw.trim()))
    }
}

function varEvalCellNumber(raw) {
    var temp = varEval(raw)
    if (temp.length != 1) {
        generateErrorAndHalt("Was expecting a single-character cell name but found '"+temp+"'.")
    } else {
        temp = cellNameToNumber(temp)
        if (temp > -1) {
            return temp
        } else {
            generateErrorAndHalt("Was expecting a single-character cell name but found '"+raw+"'.")
        }
    }
}

function compEval(theseTokens) {
    var comp = theseTokens[1]
    var v1 = (varEval(theseTokens[2])).toUpperCase()
    var v2 = (varEval(theseTokens[3])).toUpperCase()
    
    switch(comp) {
        case "is":
            return (v1 == v2)
            
        case "is not":
            return (v1 != v2)
            
        case "is in":
            return (v2.indexOf(v1) != -1)
            
        case "is not in":
            return (v2.indexOf(v1) == -1)
            
        case "never":
            return false
            
        case "always":
            return true
            
    }
}

// --------------------------- do a step ---------------------------

function doCurrentStep() {
    scriptDebugHighlightUpdate(gPC)

    var theseTokens = gSteps[gPC].stepTokens
//console.log(Date.now(),"Doing step "+gPC+" with tokens "+theseTokens)
    
    switch (theseTokens[0]) {
        case 2:                   // end proc
            // clear up the stack to the 'proc'
            gPC = stackPop('call')
            if (gPC == 0) {     // got back to the root call to 'main'
                gStillRunning = false
            }
            break
            
        case 3:                     // call
            // check to see we're not recursing
            var procName = theseTokens[1]
            if (stackFindValue('call', procName)) {
                generateErrorAndHalt("Attempted recursive call into procedure "+procName+".")
            } else {
                stackPush('call', procName, gPC)
            }
            
            var procLineNumber = theseTokens[2]
            if (procLineNumber == "find me") {       // haven't converted name to line number yet
                // so find the line that proc starts on !
                var searchString = "proc "+procName
                var finishedSearch = false
                
                var i = gSteps.length - 1
                while (!finishedSearch) {
                    if (i == 0) {
                        generateErrorAndHalt("Cannot find procedure "+procName+".")
                        finishedSearch = true
                    } else if (gSteps[i].stepText == searchString) {
                        procLineNumber = i
                        gSteps[gPC].stepTokens[2] = procLineNumber
                        scriptDebugDisplayUpdate(gPC)
                        finishedSearch = true
                    } else {
                        i--
                    }
                }
            }
            gPC = procLineNumber

            break
            
        case 5:                     // halt
            generateErrorAndHalt("Script halted.")
            break
            
        case 7:                     // comment
        case 8:                     // comment
            break
        
        case 11:                    // declare
            var varName = theseTokens[1]
            
            // xxx check here to see if it starts with '$var'
            if (varName.substring(0,4) != '$var') {
            
                generateErrorAndHalt("Attempt to create variable '"+varName+"' abandoned because it doesn't start with '$var'.")
                
            } else {
            
                var errorMessage = variableCreate(varName)
                if (errorMessage) generateErrorAndHalt(errorMessage)
            
            }
            break
            
        case 13:                    // log
            var thingToLog = varEval(theseTokens[2])
            switch (theseTokens[1]) {
                case '':
                    addToLog(thingToLog)
                    break;
                    
                case 'ln':
                    addToLog(thingToLog + gReturn)
                    break;
                    
                case 'array':
                    var elementsToLog = thingToLog.split('|')
                    for (var i=1; i<elementsToLog.length; i++) {
                        addToLog(elementsToLog[i])
                    }
                    break;
            }
            break
                
        case 14:                    // log to console
            var thingToLog = varEval(theseTokens[2])
            if (theseTokens[1] == 'array') thingToLog = util_replaceAll(thingToLog.substr(1), '[|]', gTab)
            if (theseTokens[1] == 'ln') thingToLog += gReturn
            console.log('logged at line '+gPC,thingToLog)
            break
            
        case 20:                    // background (a,b,c)
            var red = varEvalInt(theseTokens[1])
            var green = varEvalInt(theseTokens[2])
            var blue = varEvalInt(theseTokens[3])
            var temp = "rgb(" + red + "," + green + "," + blue + ")"
            
            document.body.style.backgroundColor = temp
            break
        
        case 21:                    // display text from textblock
        case 22:                    // display text from variable
            var temp = theseTokens[1]
            if (temp.substr(0,1) != '$') temp = '$textblock'+temp
            
            var theContent = varEval(temp)
            gShouldDoMoreStepsNow = false
            powi_displayTextForOKAndWait(theContent, "doCarryOn()")
            break
            
        case 23:                    // display survey from table
            var tableNumber = theseTokens[1]
            
            var finishedSearch = false
            var i = gTables.length - 1
            while (!finishedSearch) {
                if (i == -1) {
                    generateErrorAndHalt("Cannot find table named "+theseTokens[1]+".")
                    exit()
                } else if (gTables[i].name == theseTokens[1]) {
                    tableNumber = i
                    finishedSearch = true
                } else {
                    i--
                }
            }
            
            var theContent = gTables[i].content
            // now we have table number in tableNumber
            gShouldDoMoreStepsNow = false
            surv_displaySurveyAndWait(theContent, "doCarryOn()")
            break
            
        case 24:                    // cursor
                var cursorType = varEval(theseTokens[1])
                document.body.style.cursor = cursorType
            break
            
        case 33:                    // set
            var varName = theseTokens[2]
            var theValue = varEval(theseTokens[3])
            
            switch (theseTokens[1]) {
                case 'to':
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                    break
                    
                case 'appending':
                    var theValue = variableGet(varName)+theValue
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                    break
                    
                case 'replacing':
                    var theFrom = varEval(theseTokens[3])
                    var theTo = varEval(theseTokens[4])
                    var theValue = util_replaceAll(variableGet(varName), theFrom, theTo)
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                    break
                    
                case 'length':
                    var theValue = theValue.length.toString()
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                    break
                    
                case 'characters':
                    var theFrom = varEval(theseTokens[3])-1
                    var theTo = varEval(theseTokens[4])
                    var oldValue = varEval(theseTokens[5])
                    var theValue = oldValue.substring(theFrom,theTo)
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                    break
                    
                default:
                    generateErrorAndHalt("Don't know how to do that kind of set.")
            }
            break
            
        case 34:                    // set for array
            
            switch (theseTokens[1]) {
                case 'to':
                    var varName = theseTokens[2]
                    var theValue = varEval(theseTokens[3])
                    var errorMessage = variableSet(varName, gArraySeparator+theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                        break
                        
                case 'appending':
                    var varName = theseTokens[2]
                    var theValue = varEval(theseTokens[3])
                    var theValue = variableGet(varName)+gArraySeparator+theValue
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                        break
                            
                case 'length':
                    var varName = theseTokens[2]
                    var theValue = varEval(theseTokens[3])
                    var theValue = (theValue.split(gArraySeparator).length-1).toString()
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                        break
                        
                case 'toitemofarray':
                    var varName = theseTokens[2]
                    var theIndex = varEvalInt(theseTokens[3])
                    var theArray = varEval(theseTokens[4]).split(gArraySeparator)
                    if ((theIndex < 0) || (theIndex>=theArray.length)) {
                        var theValue = ''
                    } else {
                        var theValue = theArray[theIndex]
                    }
                    
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                        break
                        
                case 'itemofarrayto':
                    var theIndex = varEvalInt(theseTokens[2])
                    var varName = theseTokens[3]
                    var theValue = varEval(theseTokens[4])
                    
                    if (theIndex < 0) {
                        // do nothing
                    } else {
                        var theArray = varEval(theseTokens[3]).split(gArraySeparator)
                        theArray[theIndex] = theValue
                        theValue = theArray.join(gArraySeparator)
                        var errorMessage = variableSet(varName, theValue)
                        if (errorMessage) generateErrorAndHalt(errorMessage)
                    }
                    break
                    
                default:
                    generateErrorAndHalt("Don't know how to do that kind of set.")
            }
            break
            
        case 35:                    // extract first item of array
            
            switch (theseTokens[1]) {
                case 'extractfirst':
                    var theArray = varEval(theseTokens[2]).split(gArraySeparator)
                    var varName = theseTokens[3]
                    var theValue = theArray.splice(1,1)
                    var theValue = theValue[0]
                    
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                        
                    var varName = theseTokens[2]
                    var theValue = theArray.join(gArraySeparator)
                    
                    var errorMessage = variableSet(varName, theValue)
                    if (errorMessage) generateErrorAndHalt(errorMessage)
                break
                    
                default:
                    generateErrorAndHalt("Don't know how to do that kind of extract.")
            }
            break
            
        case 41:                    // if t1 [is/is not/is in/is not in] t2
            while (true) {
                if (compEval(theseTokens)) {    // this 'if' or 'else if' is true, so carry on with next command
                    break
                }
            
                var searchNestLevel = gSteps[gPC++].nestLevel
                while (gSteps[gPC].nestLevel != searchNestLevel) gPC++

                // you are now pointed at an 'else if' or an 'end if'
                if (gSteps[gPC].stepTokens[0] == 49) {        // it's an 'end if'
                    break
                }
                
                theseTokens = gSteps[gPC].stepTokens
            }
            break
            
        case 42:                    // else if t1 [is/is not/is in/is not in] t2
        
            // if you got here, then you were executing code and hit an 'else'
            // which means you are finished with this 'if' and need to skip to
            // the 'end if'
            
            var ifDestination = theseTokens[4]
            if (ifDestination == 'find me') {
        
                ifDestination = gPC
                var searchNestLevel = gSteps[ifDestination++].nestLevel
                while ((gSteps[ifDestination].nestLevel != searchNestLevel) || (gSteps[ifDestination].stepTokens[0] != 49)) ifDestination++
                
                // you are now pointing at the 'end if'
                gSteps[gPC].stepTokens[4] = ifDestination
                scriptDebugDisplayUpdate(gPC)
            }
            gPC = ifDestination
                
            break
            
        case 49:                    // end if
            // carry on with next command
            break
            
        case 51:                    // while t1 [is/is not/is in/is not in] t2
            if (compEval(theseTokens)) {    // carry on with next command
            
                // do nothing !
                
            } else {                        // condition is false, skip to 'end while'
            
                var searchNestLevel = gSteps[gPC++].nestLevel
                while (gSteps[gPC].nestLevel > searchNestLevel) gPC++
            }
            break
            
        case 53:                    // end while
            var returnPC = theseTokens[1]
            if (returnPC == 'find me') {
                returnPC = gPC
                var searchNestLevel = gSteps[returnPC--].nestLevel
                while (gSteps[returnPC].nestLevel > searchNestLevel) returnPC--
                
                gSteps[gPC].stepTokens[1] = --returnPC
                scriptDebugDisplayUpdate(gPC)
            }
            gPC = returnPC
            break
            
        case 56:                    // repeat n times
            var theCount = varEvalInt(theseTokens[1])
            if (theCount <= 0) {    // skip straight to the 'end repeat'
            
                var searchNestLevel = gSteps[gPC++].nestLevel
                while (gSteps[gPC].nestLevel > searchNestLevel) gPC++
                
            } else {
                stackPush('repeat', gSteps[gPC].nestLevel, theCount)
            }
            break
            
        case 57:                    // repeat for each row in table t
            var theCount = theseTokens[2]
            
            if (theCount == "find me") {       // haven't converted name to table number yet
                var finishedSearch = false
                var i = gTables.length - 1
                while (!finishedSearch) {
                    if (i == -1) {
                        generateErrorAndHalt("Cannot find table named "+theseTokens[1]+".")
                        exit()
                    } else if (gTables[i].name == theseTokens[1]) {
                        var theCount = gTables[i].content.length
                        gSteps[gPC].stepTokens[2] = theCount
                        scriptDebugDisplayUpdate(gPC)
                        finishedSearch = true
                    } else {
                        i--
                    }
                }
            }
            
            // now we have the number of repeats in theCount
            if (theCount <= 0) {    // skip straight to the 'end repeat'
            
                var searchNestLevel = gSteps[gPC++].nestLevel
                while (gSteps[gPC].nestLevel > searchNestLevel) gPC++
                
            } else {
                stackPush('repeat', gSteps[gPC].nestLevel, theCount)
            }
            break
            
        case 58:                    // end repeat
            var stackIndex = stackFindIndex('repeat', gSteps[gPC].nestLevel)
            if (--gStack[stackIndex].value > 0) {
                
                gPC = gStack[stackIndex].PC
                varsDebugDisplayUpdate(stackIndex)
                
            } else {
                stackPop('repeat')
            }
            break
            
        case 61:                    // reset table stimuli
            var tableNumber = theseTokens[1]
            
            if (tableNumber == "find me") {       // haven't converted name to table number yet
                var finishedSearch = false
                var i = gTables.length - 1
                while (!finishedSearch) {
                    if (i == -1) {
                        generateErrorAndHalt("Cannot find table named "+theseTokens[1]+".")
                        exit()
                    } else if (gTables[i].name == theseTokens[2]) {
                        gSteps[gPC].stepTokens[1] = i
                        scriptDebugDisplayUpdate(gPC)
                        tableNumber = i
                        finishedSearch = true
                    } else {
                        i--
                    }
                }
            }
            
            tableStartAgain(tableNumber)
            
            break
            
        case 62:                    // read $var1,$var2,$var3 from table stimuli
            var tableNumber = theseTokens[2]
            var varNames = theseTokens[3]
            
            if (tableNumber == "find me") {       // haven't converted name to table number yet
                var finishedSearch = false
                var i = gTables.length - 1
                while (!finishedSearch) {
                    if (i == -1) {
                        generateErrorAndHalt("Cannot find table named "+theseTokens[1]+".")
                        exit()
                    } else if (gTables[i].name == theseTokens[1]) {
                        gSteps[gPC].stepTokens[2] = i
                        scriptDebugDisplayUpdate(gPC)
                        tableNumber = i
                        finishedSearch = true
                    } else {
                        i--
                    }
                }
            }
            
            // now we have table number in tableNumber and variable names in varNames
            var thisRowOfData = tableGrabRow(tableNumber)
            var theseVariableNames = varNames.split(',')
            if (thisRowOfData.length < theseVariableNames.length) {
                generateErrorAndHalt("Not enough columns in table row "+thisRowOfData.join(',')+".")
                return
            }
            
            for (var i = 0; i<theseVariableNames.length; i++) {
                var errorMessage = variableSet(theseVariableNames[i], thisRowOfData[i])
                if (errorMessage) {
                    generateErrorAndHalt(errorMessage)
                    return
                }
            }
            break
            
        case 70:                    // move cell
            cellMoveTo(
                varEvalCellNumber(theseTokens[1]),
                varEvalInt(theseTokens[2]),
                varEvalInt(theseTokens[3]))
            break
            
        case 71:                    // show/hide cell
            cellShowHide(
                varEvalCellNumber(theseTokens[1]),
                (theseTokens[2]=="show"))
            break
            
        case 72:                    // load cell with image
            var path = (theseTokens[3]=='')?'':varEval(theseTokens[3])+"/"
            path += varEval(theseTokens[2])
            loadImageFile(varEvalCellNumber(theseTokens[1]), path)
            break
            
        case 73:                    // load cell with movie
            var path = (theseTokens[3]=='')?'':varEval(theseTokens[3])+"/"
            path += varEval(theseTokens[2])
            loadMovieFile(varEvalCellNumber(theseTokens[1]), path)
            break
            
        case 74:                    // play movie
            moviePlay(
                varEvalCellNumber(theseTokens[1]),
                (theseTokens[2]=="wait"))
            break
            
        case 75:                    // pause movie
            moviePause(
                varEvalCellNumber(theseTokens[1]))
            break  
            
        case 76:                    // load cell with text at length
            var content = varEval(theseTokens[2])
            var size = varEval(theseTokens[3])
            loadText(varEvalCellNumber(theseTokens[1]), size, content)
            break
            
        case 77:                    // load cell with sound
            var thePath = (theseTokens[3]=='')?'':varEval(theseTokens[3])+"/"
            loadSoundFile(varEvalCellNumber(theseTokens[1]), thePath, varEval(theseTokens[2]))
            break
            
        case 78:                    // play sound
            soundPlay(
                varEvalCellNumber(theseTokens[1]),
                (theseTokens[2]=="wait"))
            break
            
        case 79:                    // pause sound
            soundPause(
                varEvalCellNumber(theseTokens[1]))
            break
            
        case 81:                    // load cell with slider
            var orientation = varEval(theseTokens[2])
            var lower = varEval(theseTokens[3])
            var higher = varEval(theseTokens[4])
            var step = varEval(theseTokens[5])
            loadSlider(varEvalCellNumber(theseTokens[1]), orientation, lower, higher, step)
            break
            
        case 82:                    // set slider cell to
            var cellNumber = varEvalCellNumber(theseTokens[1])
            var theContent = varEval(theseTokens[2])
            sliderChange(cellNumber, theContent)
            break
            
        case 83:                    // set text cell to
            var cellNumber = varEvalCellNumber(theseTokens[1])
            var theContent = varEval(theseTokens[2])
            textChange(cellNumber, theContent)
            break
            
        case 91:                    // wait for clicks, keys, time
            waitForUserEvent(varEval(theseTokens[1]), varEval(theseTokens[2]), varEval(theseTokens[3]))
            gShouldDoMoreStepsNow = false
// console.log('suspending for a bit with gShouldDoMoreStepsNow=',gShouldDoMoreStepsNow)
            break
            
        case 96:                    // start timer
            gUserTimer = new Date().getTime()
            break
            
        case 97:                    // start countdown
            gUserCountdown = new Date().getTime() + (varEval(theseTokens[1]) * 1000)
            break
            
        default:
            generateErrorAndHalt("Don't know how to do step "+gPC+" with tokens "+theseTokens)
            break
    }
    
    gPC = gPC+1
    if (gShouldDoMoreStepsNow) {
        doNextStep()
    } else {
// console.log(new Date(),"Should not do more steps now.")
    }
}

// ----------------------- cells ---------------------------

function resetAllCells() {
    // remove anything currently on the screen
    for (var i=0; i<gCellNameList.length; i++) {
        var newCellId = cellNumberToFullName(i)
        var theCell = document.getElementById(newCellId)
        if (theCell) {
            theCell.parentNode.removeChild(theCell)
        }
    }
    
    // make a new Cell array
    createNewCellList()
}

// cell	vis	psyloc	winloc	type	content
function createNewCellList() {
    gCellList = []

    for (var i=0; i<gCellNameList.length; i++) {
        var newEntry = {name:cellNumberToFullName(i), visible:false, psyLocX:i, psyLocY:i, winLocX:222, winLocY:111, type:"none", sizeX:10, sizeY:10, content:"not initialised"}
        gCellList.push(newEntry)
    }
}

// ----------------------- cells ---------------------------

// Three reasons to move a cell
// A) a script changed the position or content of a cell
// B) the shape of the window has changed, move all cells
// C) the orientation of a tablet has changed, move all cells

// this is a response to the shape of the window changing
function cellWindowShapeChanged() {
    
    // resize the background div used to make the cursor types work
    var screenBackground = document.getElementById("divFullScreen")
    screenBackground.style.width = (window.innerWidth-20)+"px"
    screenBackground.style.height = (window.innerHeight-20)+"px"
    
    gWindowCenterX = window.innerWidth / 2
    gWindowCenterY = window.innerHeight / 2
    for (var i=0; i<gCellList.length; i++) {
        cellSetWinLoc(i)
        cellMoveThisThing(i)
        cellsDebugRowUpdate(i)
    }
}

function cellSetWinLoc(cellNumber) {
    gCellList[cellNumber].winLocX
        = parseInt(gWindowCenterX - (gCellList[cellNumber].sizeX / 2))
        + gCellList[cellNumber].psyLocX
    gCellList[cellNumber].winLocY
        = parseInt(gWindowCenterY - (gCellList[cellNumber].sizeY / 2))
        + gCellList[cellNumber].psyLocY
}

function cellMoveThisThing(i) {
    if (gCellList[i].type == 'none') return
    var theCell = document.getElementById(gCellList[i].name)
    theCell.style.top = gCellList[i].winLocY + "px"
    theCell.style.left = gCellList[i].winLocX + "px"
}

function cellShowHideThisThing(i) {
    if (gCellList[i].type == 'none') return
    var theCell = document.getElementById(gCellList[i].name)
    var toShow = gCellList[i].visible
    theCell.style.visibility = (toShow)?'visible':'hidden'
        
    if (toShow && (gCellList[i].type == "text")) {
        theCell.focus()
        theCell.select()
    }
    
}

// -------------------- cell commands ----------------------

function cellMoveTo(cellNumber, newX, newY) {
    gCellList[cellNumber].psyLocX = newX
    gCellList[cellNumber].psyLocY = newY
    
    cellSetWinLoc(cellNumber)
    cellMoveThisThing(cellNumber)
    cellsDebugRowUpdate(cellNumber)
}

function cellShowHide(cellNumber, toShow) {
    gCellList[cellNumber].visible = toShow
    
    cellShowHideThisThing(cellNumber)
    cellsDebugRowUpdate(cellNumber)
}

function cellChangeTypeTo(cellNumber,newType) {

    // first, get rid of any existing cell
    switch (gCellList[cellNumber].type) {
    
        case newType:        // it's already the right type
            return document.getElementById(gCellList[cellNumber].name)
            
        case 'none':        // nothing there to get rid of
            break
            
        default:            // there's something there we don't like
            // I'm trusting this to remove all event listeners since it removes the thing the event happens to
            var theOldObject = document.getElementById(gCellList[cellNumber].name)
            theOldObject.parentNode.removeChild(theOldObject)
            
    }
    
    // now create a new one
    switch (newType) {
    
        case 'none':    // this is here for symmetry.  I don't think it's ever used
            return
    
        case 'slider':
            var sliderPart = document.createElement('input')
            sliderPart.type = "range"
            sliderPart.min = 0
            sliderPart.max = 99
            sliderPart.step = 5
            sliderPart.value = 5
            sliderPart.id = gCellList[cellNumber].name
            sliderPart.name = cellNumber
            sliderPart.style.position = "absolute"
            sliderPart.style.visibility = (gCellList[cellNumber].visible)?"visible":"hidden"
            sliderPart.addEventListener('change', sliderChanged, false)
            document.body.appendChild(sliderPart)
            return sliderPart
    
        case 'text':
            var textPart = document.createElement('input')
            textPart.type = "text"
            textPart.size = 30
            textPart.value = "not initialized"
            textPart.id = gCellList[cellNumber].name
            textPart.name = cellNumber
            textPart.style.position = "absolute"
            textPart.style.fontSize = "large"
            textPart.style.visibility = (gCellList[cellNumber].visible)?"visible":"hidden"
            textPart.addEventListener('change', textChanged, false)
            textPart.addEventListener('keyup', textChanged, false)
            document.body.appendChild(textPart)
            return textPart
    
        case 'movie':
            var videoPart = document.createElement('video')
            videoPart.id = gCellList[cellNumber].name
            videoPart.name = cellNumber
            videoPart.style.position = "absolute"
            videoPart.style.visibility = (gCellList[cellNumber].visible)?"visible":"hidden"
            videoPart.addEventListener('canplaythrough', movieCanPlayThrough, false)
            videoPart.addEventListener('error', movieError, false)
            videoPart.addEventListener('click', cellClick, false)
            document.body.appendChild(videoPart)
            return videoPart
    
        case 'sound':
            var soundPart = new Audio()
            soundPart.id = gCellList[cellNumber].name
            soundPart.name = cellNumber
            soundPart.controls = "controls"
            soundPart.style.position = "absolute"
            soundPart.style.visibility = (gCellList[cellNumber].visible)?"visible":"hidden"
            soundPart.addEventListener('canplaythrough', soundCanPlayThrough, false)
            soundPart.addEventListener('error', soundError, false)
            document.body.appendChild(soundPart)
            return soundPart
    
        case 'image':
            var imagePart = new Image()
            imagePart.id = gCellList[cellNumber].name
            imagePart.name = cellNumber
            imagePart.style.position = "absolute"
            imagePart.style.visibility = (gCellList[cellNumber].visible)?"visible":"hidden"
            imagePart.addEventListener('load', imageLoaded, false)
            imagePart.addEventListener('error', imageError, false)
            imagePart.addEventListener('mousedown', cellClick, false)
            document.body.appendChild(imagePart)
            return imagePart
    
        default:            // there's something there we don't like
            generateErrorAndHalt("Don't know how to make a cell of type '"+newType+"'.")
            
    }
}

// ----------------------- stack ---------------------------

// pushes one more item of any kind onto the stack
function stackPush(theType,theName,theValue) {
    gStack.push({PC:gPC,type:theType,name:theName,value:theValue})
    varsDebugDisplayInit()
    varsDebugDisplayUpdate(gStack.length-1)
}

// pops the stack until it finds an item of the type specified
// at which point it returns the value of that item
// if no such item is found, returns -1
function stackPop(theType) {
    for (var i=gStack.length-1; i>0; i--) {
        if (gStack[i].type == theType) {    // found it !
        
            while (gStack.length > i) {
                var lastThing = gStack.pop()
            }
            
            varsDebugDisplayInit()
            varsDebugDisplayUpdate(gStack.length-1)
            return lastThing.value
        }
    }
    return -1
}

// finds the thing specified on the stack and returns its INDEX
function stackFindIndex(theType,theName) {
    for (var i=gStack.length-1; i>0; i--) {
        if ((gStack[i].type == theType) && (gStack[i].name == theName)) {
            return i
        }
    }
    return -1
}

// finds the thing specified on the stack and returns its value
function stackFindValue(theType,theName) {
    var theIndex = stackFindIndex(theType,theName)
    return (theIndex == -1)?false:gStack[theIndex].value
}

// ----------------------- variables ---------------------------

// returns index on stack for variable of that name
function variableFind(theName) {
    return stackFindIndex('variable',theName)
}

// checking to see if the variable was declared at this level
// intended to be used by 'declare' to check that you didn't already
// declare this variable at this level
function variableFindTop(theName) {
    for (var i=gStack.length-1; i>0; i--) {
        if (gStack[i].type == "variable" && gStack[i].name == theName)
            return i
        if (gStack[i].type != "variable") return -1
    }
    return -1
}

function variableCreate(theName, rawValue) {
    var theValue = "not initialised"
    if (typeof(rawValue) !=='undefined') theValue = rawValue
    if (variableFindTop(theName) == -1) {
        stackPush("variable",theName,theValue)
        return false
    } else {
        return "Variable with that name already declared in this scope."
    }
}

function variableSet(theName, theValue) {
    var varPos = variableFind(theName)
    if (varPos == -1) {
        return "No such variable."
    } else {
        gStack[varPos].value = theValue
        varsDebugDisplayUpdate(varPos)
        return false
    }
}

function variableGet(theName) {
    var varPos = variableFind(theName)
    if (varPos == -1) {
        return "No such variable '"+theName+"'."
    } else {
        return gStack[varPos].value
    }
}

// -------------------------------- slider -------------------------------

function loadSlider(cellNumber, orientation, lower, higher, step) {
    var sliderPart = cellChangeTypeTo(cellNumber,'slider')
    sliderPart.orient = orientation
    sliderPart.style = "-webkit-appearance: slider-"+orientation+";"
    sliderPart.min = lower
    sliderPart.max = higher
    if (step == 'none') {
        sliderPart.step = ''
    } else {
        sliderPart.step = step
    }
    sliderPart.value = lower
    
    gCellList[cellNumber].type = 'slider'
    gCellList[cellNumber].content = lower
    
    gCellList[cellNumber].sizeX = sliderPart.offsetWidth
    gCellList[cellNumber].sizeY = sliderPart.offsetHeight
    cellSetWinLoc(cellNumber)
    cellMoveThisThing(cellNumber)
    cellsDebugRowUpdate(cellNumber)
}

function sliderChange(cellNumber, theContent) {
    if (gCellList[cellNumber].type != 'slider') generateErrorAndHalt("You are using a slider command to change something that isn't a slider.")
    var theCell = document.getElementById(gCellList[cellNumber].name)
    theCell.value = theContent
    gCellList[cellNumber].content = theContent
    cellsDebugRowUpdate(cellNumber)
}

function sliderChanged(theEvent) {
    var theCell = theEvent.target
    var cellNumber = theCell.name

    gCellList[cellNumber].content = theCell.value
    cellsDebugRowUpdate(cellNumber)
}

// -------------------------------- text -------------------------------

function loadText(cellNumber, theSize, theContent) {
    var textPart = cellChangeTypeTo(cellNumber,'text')
    textPart.size = theSize
    textPart.value = theContent
    
    gCellList[cellNumber].type = 'text'
    gCellList[cellNumber].content = theContent
    
    gCellList[cellNumber].sizeX = textPart.offsetWidth
    gCellList[cellNumber].sizeY = textPart.offsetHeight
    cellSetWinLoc(cellNumber)
    cellMoveThisThing(cellNumber)
    cellsDebugRowUpdate(cellNumber)
}

function textChange(cellNumber, theContent) {
    if (gCellList[cellNumber].type != 'text') generateErrorAndHalt("You are using a text command to change something that isn't a text.")
    var theCell = document.getElementById(gCellList[cellNumber].name)
    theCell.value = theContent
    gCellList[cellNumber].content = theContent
    cellsDebugRowUpdate(cellNumber)
}

function textChanged(theEvent) {
    var theCell = theEvent.target
    var cellNumber = theCell.name

    gCellList[cellNumber].content = theCell.value
    cellsDebugRowUpdate(cellNumber)
}

// -------------------------------- sound -------------------------------

function loadSoundFile(cellNumber, thePath, theFileList) {
    var soundPart = cellChangeTypeTo(cellNumber,'sound')
    
    gSoundFileList = theFileList.split(gArraySeparator)
    for (var i = gSoundFileList.length - 1; i >= 0; i--) {
        gSoundFileList[i] = thePath+gSoundFileList[i]
    }
    
    gCellList[cellNumber].type = 'sound'
    gCellList[cellNumber].content = gSoundFileList.join(gArraySeparator)
    
    // next line is to provide a status meaning 'I am waiting for this sound to load'
    gCellList[cellNumber].loadStatus = 'new'
        
    cellsDebugRowUpdate(cellNumber)
    tryLoadingNextSoundFile(cellNumber, soundPart)
}
    
function tryLoadingNextSoundFile(cellNumber, soundPart) {
    if (gSoundFileList.length == 0) {
        generateErrorAndHalt("Was unable to find a sound file in a format that this browser would play.")
    
    } else {
        var nextSoundFile = gScriptPath+gSoundFileList.shift()
        if (soundPart.src == nextSoundFile) return
        
        gShouldDoMoreStepsNow = false
        soundPart.src = nextSoundFile
        gCellList[cellNumber].loadStatus = 'loading'
    }
}

function soundCanPlayThrough(theEvent) {
    var theCell = theEvent.target
    var cellNumber = theCell.name
        
    // following line in here because Chrome fires 'canPlayThrough' not just when you load it
    // but every time you play the movie
    if (gCellList[cellNumber].loadStatus != 'loading') return
        
    // if we got this far a sound was loading
    gCellList[cellNumber].loadStatus = 'canplaythrough'
//    theCell.removeEventListener('canplaythrough', soundCanPlayThrough, false)
    
    gCellList[cellNumber].content = theEvent.target.src
    gCellList[cellNumber].sizeX = 300
    gCellList[cellNumber].sizeY = 20
    cellSetWinLoc(cellNumber)
    cellMoveThisThing(cellNumber)
    cellsDebugRowUpdate(cellNumber)
    doCarryOn()
}

function soundError(theEvent) {
    var theErrorCode = theEvent.target.error.code
    if ((theErrorCode == 3) || (theErrorCode == 4)){
        var theCell = theEvent.target
        var cellNumber = theCell.name
        var soundPart = document.getElementById(gCellList[cellNumber].name)
        tryLoadingNextSoundFile(cellNumber, soundPart)
    } else {
        var thePath = theEvent.target.src
        gPC--       // error message will report wrong line because execution has already moved on
        generateErrorAndHalt("Cannot load sound '"+thePath+"' because of error "+theErrorCode+".")
    }
}

function soundPause(cellNumber) {
    if (gCellList[cellNumber].type != 'sound') generateErrorAndHalt("You are using a sound command to pause something that isn't a sound.")
    var soundPart = document.getElementById(gCellList[cellNumber].name)
    soundPart.pause()
}

function soundPlay(cellNumber, shouldWaitForEnd) {
    if (gCellList[cellNumber].type != 'sound') generateErrorAndHalt("You are using a sound command to play something that isn't a sound.")
    var soundPart = document.getElementById(gCellList[cellNumber].name)
    if (shouldWaitForEnd) {
        soundPart.addEventListener('ended', soundEnded, false)
        gShouldDoMoreStepsNow = false
    }
    soundPart.play()
}

function soundEnded(theEvent) {
    var theCell = theEvent.target
    theCell.removeEventListener('ended', soundEnded, false)
    doCarryOn()
}

// -------------------------------- movies -------------------------------

function loadMovieFile(cellNumber, fileName) {
    if ((gCellList[cellNumber].type == 'movie') && (gCellList[cellNumber].content == fileName)) {
        return
    }
    var videoPart = cellChangeTypeTo(cellNumber,'movie')
    videoPart.src = gScriptPath+fileName
    
    gCellList[cellNumber].type = 'movie'
    gCellList[cellNumber].content = fileName
    gCellList[cellNumber].loadStatus = 'loading'
    gShouldDoMoreStepsNow = false
}

function movieCanPlayThrough(theEvent) {
    var theCell = theEvent.target
    var cellNumber = theCell.name
    
    // following line in here because Chrome fires 'canPlayThrough' not just when you load it
    // but every time you play the movie
    if (gCellList[cellNumber].loadStatus != 'loading') return
    
    // if we got this far a movie was loading
    gCellList[cellNumber].loadStatus = 'canplaythrough'
//    theCell.removeEventListener('canplaythrough', movieCanPlayThrough, false)
    
    gCellList[cellNumber].sizeX = theCell.videoWidth
    gCellList[cellNumber].sizeY = theCell.videoHeight
    cellSetWinLoc(cellNumber)
    cellMoveThisThing(cellNumber)
    cellsDebugRowUpdate(cellNumber)
    doCarryOn()
}

function movieError(theEvent) {
    var thePath = theEvent.target.src
    var theErrorCode = theEvent.target.error.code
    gPC--       // error message will report wrong line because execution has already moved on
    if (theErrorCode == 4) {
        generateErrorAndHalt("Cannot load movie '"+thePath+"' because it is missing or because movies in that format are not supported by this browser.")
    } else {
        generateErrorAndHalt("Cannot load movie '"+thePath+"' because of error "+theErrorCode)
    }
}

function moviePause(cellNumber) {
    if (gCellList[cellNumber].type != 'movie') generateErrorAndHalt("You are using a movie command to pause something that isn't a movie.")
    var videoPart = document.getElementById(gCellList[cellNumber].name)
    videoPart.pause()
}

function moviePlay(cellNumber, shouldWaitForEnd) {
    if (gCellList[cellNumber].type != 'movie') generateErrorAndHalt("You are using a movie command to play something that isn't a movie.")
    var videoPart = document.getElementById(gCellList[cellNumber].name)
    if (shouldWaitForEnd) {
        
        // one or the other of these, not both
        videoPart.addEventListener('ended', movieEnded, false)
        // var theTime = videoPart.duration * 1000
        // window.setTimeout("movieTimeFinished()", theTime)
        
        gShouldDoMoreStepsNow = false
    }
    videoPart.currentTime = 0
    videoPart.play()
}

function movieEnded(theEvent) {
    var theCell = theEvent.target
    theCell.removeEventListener('ended', movieEnded, false)
    doCarryOn()
}
    
function movieTimeFinished() {
    doCarryOn()
}

// -------------------------------- images -------------------------------

function loadImageFile(cellNumber, fileName) {
    if ((gCellList[cellNumber].type == 'image') && (gCellList[cellNumber].content == fileName)) {
        return
    }
    
    var imagePart = cellChangeTypeTo(cellNumber,'image')
    imagePart.src = gScriptPath+fileName
    
    gCellList[cellNumber].type = 'image'
    gCellList[cellNumber].content = fileName
    gShouldDoMoreStepsNow = false
}

function imageLoaded(theEvent) {
    var theCell = theEvent.target
    var cellNumber = theCell.name
    
    gCellList[cellNumber].sizeX = theCell.naturalWidth
    gCellList[cellNumber].sizeY = theCell.naturalHeight
    cellSetWinLoc(cellNumber)
    cellMoveThisThing(cellNumber)
    cellsDebugRowUpdate(cellNumber)
    doCarryOn()
}

function imageError(theEvent) {
    var thePath = theEvent.target.src
//    var theErrorCode = theEvent.target.error.code
//    generateErrorAndHalt("Cannot load image '"+thePath+"'. because of error "+theErrorCode)
//    var theErrorCode = theEvent.target.error.code
    gPC--       // error message will report wrong line because execution has already moved on
    generateErrorAndHalt("Cannot load image '"+thePath+"'.")
}

// --------------------------- timer and countdown ----------------------------

function initTimerCountdown() {
    gUserTimer = new Date().getTime()
    gUserCountdown = new Date().getTime()
}

// -------------------------------- wait events -------------------------------

function initEventVariables() {
    gWaitingForClick = false
    gWaitingForClickAllowableCells = ""
    
    gWaitingForKey = false
    gWaitingForClickAllowableKeys = ""
    
    gWaitingForTime = false
    
    gScriptVars = new Object
    gScriptVars.leTimeoutHandle = false
    
    gScriptVars.leStartTime = new Date().getTime()
    gScriptVars.leEndTime = new Date().getTime()
    gScriptVars.leEnder = 'none'
    gScriptVars.leLastKey = 'none'
    gScriptVars.leLastClick = 'none'
    gScriptVars.leLastClickX = 'none'
    gScriptVars.leLastClickY = 'none'
    
    gScriptVars.lsResponses = 'none'
}

// if any of these are false then that sort of event is to be ignored
function waitForUserEvent(theClicks, theKeys, theTime) {

    gScriptVars.leStartTime = new Date().getTime()

    if (theClicks != 'none') {
        gWaitingForClick = true
        gWaitingForClickAllowableCells = theClicks
    }
    if (theKeys != 'none') {
        gWaitingForKey = true
        gWaitingForClickAllowableKeys = theKeys
    }
    if (theTime != 'none') {
        gWaitingForTime = true
        gScriptVars.leTimeoutHandle = setTimeout("pauseTimeUp()", theTime * 1000)
    }
    
}

function bodyKeypress(theEvent) {
    if (gpowi_popupStillShowing) powi_gkeyPressed(theEvent.charCode)
    if (!gWaitingForKey) return
    
    gScriptVars.leEndTime = theEvent.timeStamp
    gScriptVars.leLastKey = String.fromCharCode(theEvent.charCode)
    if (gWaitingForClickAllowableKeys.indexOf(gScriptVars.leLastKey) == -1) return
    
    gScriptVars.leEnder = 'key'
    gScriptVars.leEndTime = theEvent.timeStamp
    // stupid FireFox doesn't do that correctly so we have to do this
    if (gScriptVars.leEndTime < gScriptVars.leStartTime) gScriptVars.leEndTime = new Date().getTime()
    resumeAfterWait()
}

function cellClick(theEvent) {
    if (!gWaitingForClick) return
    
    var temp = theEvent.target.id
    gScriptVars.leLastClick = temp.substr(4)
    if (gWaitingForClickAllowableCells.indexOf(gScriptVars.leLastClick) == -1) return
    
    gScriptVars.leEnder = 'click'
    
    gScriptVars.leEndTime = theEvent.timeStamp
    // stupid FireFox doesn't do that correctly so we have to do this
    if (gScriptVars.leEndTime < gScriptVars.leStartTime) gScriptVars.leEndTime = new Date().getTime()
    // use clientX and clientY ?
    gScriptVars.leLastClickX = theEvent.offsetX
    gScriptVars.leLastClickY = theEvent.offsetY
    resumeAfterWait()
}

function pauseTimeUp() {
    gScriptVars.leEndTime = new Date().getTime()
    if (!gWaitingForTime) return
    
    gScriptVars.leEnder = 'time'
    resumeAfterWait()
}

function resumeAfterWait() {
    if (gWaitingForTime) {
        window.clearTimeout(gScriptVars.leTimeoutHandle)
    }
    gWaitingForTime = false
    gWaitingForKey = false
    gWaitingForClick = false

    doCarryOn()
}

// -------------------------- table operations -------------------------

function tableGrabRow(tableNumber) {
    if (gTables[tableNumber].unused.length == 0) tableStartAgain(tableNumber)
    
    var temp = gTables[tableNumber].unused.shift()
    
    tableDebugDisplayUpdate(tableNumber)
    return temp
}

function tableStartAgain(tableNumber) {
    gTables[tableNumber].unused = array_clone(gTables[tableNumber].content)
    if (gTables[tableNumber].order != "random") return
    
    // else randomise the order of thisTable.unused elements
    var thisTable = gTables[tableNumber].unused
    for (var i=thisTable.length-1; i>=0; i--) {
        var j = Math.floor(Math.random() * thisTable.length)
        var temp = array_clone(thisTable[i])
        var temp2 = array_clone(thisTable[j])
        thisTable[i] = temp2
        thisTable[j] = temp
    }
}

function array_clone(raw) {
    var cooked = []
    for (var i=0; i<raw.length; i++) {
        cooked.push(raw[i])
    }
    return cooked
}
