function surv_displaySurveyAndWait(theSurvey, theContinueFunction) {
    surv_displaySurvey(theSurvey)
    surv_waitUntilWindowGone(theContinueFunction)
}

function surv_displaySurvey(theSurvey) {
    // create new array of response fields.  These will be used when the survey is dismissed.
    surv_gResponseFields = []
    
    for (var i = theSurvey.length-1; i>=0; i--) {
        var thisRowSpec = theSurvey[i]

        // replace this with something which generates the appropriate rows
        
        switch (thisRowSpec[0]) {
            case 'showtext':
            case 'show text':
                var newLabel = document.createElement("p")
                newLabel.style.maxWidth = "583px"
                newLabel.appendChild(document.createTextNode(thisRowSpec.slice(1).join(',')))
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.appendChild(surv_makeCell(newLabel,2))
                break
                
            case 'showimage':
            case 'show image':
                var newLabel = document.createElement("img")
                newLabel.src = gScriptPath + thisRowSpec[1]
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.align = "center"
                thisRowOut.appendChild(surv_makeCell(newLabel,2))
                break
                
            case 'radioline':
            case 'radio line':
                if (thisRowSpec.length < 2) thisRowSpec[1] = 'no label given'
                    if (thisRowSpec.length < 3) thisRowSpec[2] = 'no options given'
                        
                        var newLabel = document.createElement("p")
                        newLabel.align = "right"
                        var newLabelNode = document.createTextNode(thisRowSpec[1])
                        newLabel.appendChild(newLabelNode)
                        
                        var newInput = document.createElement("fieldset")
                        
                        for (var j=2; j<thisRowSpec.length; j++) {
                            var newOptionInput = document.createElement("input")
                            newOptionInput.type = "radio"
                            newOptionInput.name = "radioline"+i
                            newOptionInput.id = "radioline"+i+"o"+j
                            if (j==2) newOptionInput.checked = "checked"
                                newOptionInput.value = thisRowSpec[j]
                                
                                var newOptionLabel = document.createElement("label")
                                newOptionLabel.for = "radioline"+i+"o"+j
                                    var newLabelNode = document.createTextNode(thisRowSpec[j]+"   ")
                                    newOptionLabel.appendChild(newLabelNode)
                                    
                                    newInput.appendChild(newOptionInput)
                                    newInput.appendChild(newOptionLabel)
                                    }
                surv_gResponseFields.unshift(newInput)
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.appendChild(surv_makeCell(newLabel,1))
                thisRowOut.appendChild(surv_makeCell(newInput,1))
                break
                
            case 'radiocolumn':
            case 'radio column':
                if (thisRowSpec.length < 2) thisRowSpec[1] = 'no label given'
                if (thisRowSpec.length < 3) thisRowSpec[2] = 'no options given'
                        
                var newLabel = document.createElement("p")
                newLabel.align = "right"
                var newLabelNode = document.createTextNode(thisRowSpec[1])
                newLabel.appendChild(newLabelNode)
                
                var newInput = document.createElement("fieldset")
                
                for (var j=2; j<thisRowSpec.length; j++) {
                    var newOptionInput = document.createElement("input")
                    newOptionInput.type = "radio"
                    newOptionInput.name = "radioline"+i
                    newOptionInput.id = "radioline"+i+"o"+j
                    if (j==2) newOptionInput.checked = "checked"
                    newOptionInput.value = thisRowSpec[j]
                    
                    var newOptionLabel = document.createElement("label")
                    newOptionLabel.for = "radioline"+i+"o"+j
                    var newLabelNode = document.createTextNode(thisRowSpec[j]+"   ")
                    newOptionLabel.appendChild(newLabelNode)
                    
                    if (j>2) {
                        newInput.appendChild(document.createElement("br"))
                    }
                    newInput.appendChild(newOptionInput)
                    newInput.appendChild(newOptionLabel)
                        
                }
                surv_gResponseFields.unshift(newInput)
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.appendChild(surv_makeCell(newLabel,1))
                thisRowOut.appendChild(surv_makeCell(newInput,1))
                break
                
            case 'shorttext':
            case 'short text':
                if (thisRowSpec.length < 3) thisRowSpec[2] = 15
                
                var newLabel = document.createElement("p")
                newLabel.align = "right"
                var newLabelNode = document.createTextNode(thisRowSpec[1])
                newLabel.appendChild(newLabelNode)
                
                var newInput = document.createElement("input")
                newInput.type = "text"
                newInput.size = thisRowSpec[2]
                newInput.value = ""
                surv_gResponseFields.unshift(newInput)
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.appendChild(surv_makeCell(newLabel,1))
                thisRowOut.appendChild(surv_makeCell(newInput,1))
                break
                
            case 'longtext':
            case 'long text':
                if (thisRowSpec.length < 3) thisRowSpec[2] = 15
                
                var newLabel = document.createElement("p")
                var newLabelNode = document.createTextNode(thisRowSpec[1])
                newLabel.appendChild(newLabelNode)
                
                var newInput = document.createElement("textarea")
                newInput.rows = "5"
                newInput.cols = "80"
                newInput.value = ""
                surv_gResponseFields.unshift(newInput)
                
                var newCell = surv_makeCell(newLabel,2)
                // newCell.appendChild(document.createElement("br"))
                newCell.appendChild(newInput)
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.appendChild(newCell)
                break
                
            case 'slider':
                if (thisRowSpec.length == 4) {
                    thisRowSpec[4] = ''
                    thisRowSpec[5] = ''
                }
                if (thisRowSpec.length != 6) thisRowSpec = ['slider','slider incorrectly specified',1,3,'low','high']
                    
                var newLabel = document.createElement("p")
                newLabel.align = "right"
                var newLabelNode = document.createTextNode(thisRowSpec[1])
                newLabel.appendChild(newLabelNode)
                
                var newInput = document.createElement("input")
                newInput.type = "range"
                newInput.min = thisRowSpec[2]
                newInput.max = thisRowSpec[3]
                newInput.step = 1
                newInput.value = (parseInt(thisRowSpec[2]) + parseInt(thisRowSpec[3])) / 2
                surv_gResponseFields.unshift(newInput)
                    
                var newInputCell = surv_makeCell(newInput,1)
                newInputCell.align = "center"
                var temp = document.createTextNode(thisRowSpec[4]+" ")
                newInputCell.insertBefore(temp ,newInputCell.firstChild)
                var temp = document.createTextNode(" "+thisRowSpec[5])
                newInputCell.appendChild(temp)
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.appendChild(surv_makeCell(newLabel,1))
                thisRowOut.appendChild(newInputCell)
                break
                    
            case 'continue':    // set the text for the continue button and label
                var newButtonText = thisRowSpec[1]
                surv_gContinueButton.removeChild(surv_gContinueButton.firstChild)
                surv_gContinueButton.appendChild(document.createTextNode(newButtonText))
                    
                var newLabelText = thisRowSpec.slice(2).join(',')
                surv_gContinueLabel.removeChild(surv_gContinueLabel.firstChild)
                surv_gContinueLabel.appendChild(document.createTextNode(newLabelText))
                var thisRowOut = document.createElement("tr")
                break
                
            default:
                var newInput = document.createElement("textarea")
                newInput.rows = "5"
                newInput.cols = "80"
                newInput.value = "Cannot make sense of the row '"+ JSON.stringify(thisRowSpec) +"'.'"
                
                var thisRowOut = document.createElement("tr")
                thisRowOut.appendChild(surv_makeCell(newInput,2))
        }
        surv_gDisplaySurveyTable.insertBefore(
            thisRowOut,
            surv_gDisplaySurveyTable.firstChild)
    }
    // that's the rows
    
    surv_gDisplaySurveyDiv.style.display = 'block'
    surv_gPopupStillShowing = true
}

function surv_gDisplayButtonClicked() {
    // copy out all the results    
    var resultList = ""
    for (var i = 0; i<surv_gResponseFields.length; i++) {
        if (surv_gResponseFields[i].type == "fieldset") {       // radiobuttons
            var theOptions = surv_gResponseFields[i].children   // technically this includes labels as well
            var selectedOne = "none selected somehow"
            for (var j = 0; j< theOptions.length; j++) {
                if (theOptions[j].checked) {
                    selectedOne = theOptions[j].value
                }
            }
            resultList += "|"+selectedOne
        } else {
            resultList += "|"+surv_gResponseFields[i].value
        }
    }
    gScriptVars.lsResponses = resultList
    
    // remove all table lines apart from the 'Continue' one
    while (surv_gDisplaySurveyTable.childElementCount > 1) {
        surv_gDisplaySurveyTable.removeChild(surv_gDisplaySurveyTable.firstChild)
    }
    
    surv_gDisplaySurveyDiv.style.display = 'none'
    surv_gPopupStillShowing = false
}

function surv_waitUntilWindowGone(theContinueFunction) {
    if (surv_gPopupStillShowing) {
        window.setTimeout('surv_waitUntilWindowGone("'+theContinueFunction+'")', 1000)
    } else {
        eval(theContinueFunction)
    }
}

// -------------------  make survey popup --------------------

surv_makeSurveyPopup()

function surv_makeSurveyPopup() {
    surv_gDisplaySurveyTable = document.createElement("table")
    surv_gDisplaySurveyTable.style.background = "#E0E0E0"

    // last row, featuring the 'Continue' button
    var lastRow = document.createElement("tr")

    surv_gContinueLabel = document.createElement("p")
    surv_gContinueLabel.style.maxWidth = "250px"
    surv_gContinueLabel.innerHTML = "Click the 'Continue' button when you're happy with your answers."
    var temp2 = surv_makeCell(surv_gContinueLabel,1)
    temp2.align = "right"
    lastRow.appendChild(temp2)

    surv_gContinueButton = document.createElement("button")
    surv_gContinueButton.innerHTML = 'Continue'
    surv_gContinueButton.addEventListener('click', surv_gDisplayButtonClicked, false)
    lastRow.appendChild(surv_makeCell(surv_gContinueButton,1))
    surv_gDisplaySurveyTable.appendChild(lastRow)

    surv_gDisplaySurveyDiv = document.createElement("div")
    surv_gDisplaySurveyDiv.appendChild(surv_gDisplaySurveyTable)
    surv_gDisplaySurveyDiv.className = 'divDisplayText'
    surv_gDisplaySurveyDiv.style.display = 'none'
    
    document.body.appendChild(surv_gDisplaySurveyDiv)
    
    surv_gPopupStillShowing = false
}

function surv_makeCell(content, theSpan) {
    var temp = document.createElement("td")
    if (theSpan != 1) temp.colSpan = theSpan
    temp.appendChild(content)
    
    return temp
}
